Imports FieldSoftware.PrinterCE_NetCF
Imports Microsoft.VisualBasic 

Public Class dzPrinterCE
    Implements IDisposable

    Private orBarcodeCE As BarcodeCE

    Public Sub New()
        orBarcodeCE = New BarcodeCE()
        'orBarcodeCE.SetupPrinterOther(PrinterCE_Base.FORMFEED_SETTING.PAPERHEIGHT, -1, PrinterCE_Base.DENSITY.NORMAL, PrinterCE_Base.SERIAL_HANDSHAKE.USE_CURRENT, PrinterCE_Base.BITFLAG.USE_CURRENT, PrinterCE_Base.COMPRESSION.USE_CURRENT, PrinterCE_Base.DITHER.USE_CURRENT, PrinterCE_Base.PRINTQUALITY.USE_CURRENT)
    End Sub
    
    Public Sub New(initstr as String )
        orBarcodeCE = New BarcodeCE(initstr)
        'orBarcodeCE.SetupPrinterOther(PrinterCE_Base.FORMFEED_SETTING.PAPERHEIGHT, -1, PrinterCE_Base.DENSITY.NORMAL, PrinterCE_Base.SERIAL_HANDSHAKE.USE_CURRENT, PrinterCE_Base.BITFLAG.USE_CURRENT, PrinterCE_Base.COMPRESSION.USE_CURRENT, PrinterCE_Base.DITHER.USE_CURRENT, PrinterCE_Base.PRINTQUALITY.USE_CURRENT)
    End Sub

    Public Sub SelectPrinter(ByVal StartPrinting As Boolean)
        orBarcodeCE.SelectPrinter(StartPrinting)
    End Sub

	Public Sub SetupPrinter
		'orBarcodeCE.SetupPrinterOther(PrinterCE_Base.FORMFEED_SETTING.PAPERHEIGHT, -1, PrinterCE_Base.DENSITY.NORMAL, PrinterCE_Base.SERIAL_HANDSHAKE.USE_CURRENT, PrinterCE_Base.BITFLAG.USE_CURRENT, PrinterCE_Base.COMPRESSION.USE_CURRENT, PrinterCE_Base.DITHER.USE_CURRENT, PrinterCE_Base.PRINTQUALITY.USE_CURRENT)
		orBarcodeCE.SetupPrinterOther(PrinterCE_Base.FORMFEED_SETTING.USE_CURRENT, -1, PrinterCE_Base.DENSITY.NORMAL, PrinterCE_Base.SERIAL_HANDSHAKE.USE_CURRENT, PrinterCE_Base.BITFLAG.USE_CURRENT, PrinterCE_Base.COMPRESSION.USE_CURRENT, PrinterCE_Base.DITHER.USE_CURRENT, PrinterCE_Base.PRINTQUALITY.USE_CURRENT)

	End Sub

    Public Property PrLeftMargin() As Double
        Get
            Return orBarcodeCE.PrLeftMargin
        End Get
        Set(ByVal Value As Double)
            orBarcodeCE.PrLeftMargin = Value
        End Set
    End Property

    Public Property FontBold() As Boolean
        Get
            Return orBarcodeCE.FontBold
        End Get
        Set(ByVal Value As Boolean)
            orBarcodeCE.FontBold = Value
        End Set
    End Property
    
    Public Property FontSize() As Integer
        Get
            Return orBarcodeCE.FontSize 
        End Get
        Set(ByVal Value As Integer)
            orBarcodeCE.FontSize = Value
        End Set
    End Property
    
    Public Sub ShutDown()
        orBarcodeCE.ShutDown()
    End Sub

    Public Sub DrawText(ByVal Text As String, x as Double, y as Double)
        orBarcodeCE.ScaleMode = barcodece.MEASUREMENT_UNITS.CENTIMETERS 
        
        orBarcodeCE.DrawText(Text, x, y, -1)
    End Sub

	
	
	'Public Function DrawUPC13(ByVal leftstr As String, ByVal rightstr As String, ByVal x As Double, ByVal y As Double, ByVal hpercent As Integer) as Double 
	Public Function DrawEAN13(ByVal BarcodeStr As String, ByVal x As Double, ByVal y As Double, ByVal hpercent As Integer) as Double 
		Dim wid As Double 
		'Dim y As Double 
		Dim str as String 
		
		Dim leading As String
		Dim leftstr As String 
		Dim rightstr As String 
		Dim extra As String 
		
		str = BarcodeStr
		
		
		leading = Microsoft.VisualBasic.Left(str, 1)
		leftstr = Microsoft.VisualBasic.Mid(str, 2, 6)
		rightstr = Microsoft.VisualBasic.Mid(str, 8, 5)
		
		
		extra = ""
		'y = 0
		'return orbarcodece.DrawUPC("781572", "31856", 0.5, 0, BarcodeCE.BARCODE_FONTSIZE.NO_TEXT, BarcodeCE.TYPE_UPC.UPC13, 0, BarcodeCE.BARCODE_FIT.TIGHT, 65)
		'wid = orbarcodece.DrawUPC(leftstr, rightstr, extra, x, y, BarcodeCE.BARCODE_FONTSIZE.NO_TEXT, BarcodeCE.TYPE_UPC.UPC13, Val(firststr), BarcodeCE.BARCODE_FIT.TIGHT, 65)
		Try 
			orBarcodeCE.ScaleMode = barcodece.MEASUREMENT_UNITS.CENTIMETERS 
			
			wid = orbarcodece.DrawUPC(leftstr, rightstr, extra, x, y, false, BarcodeCE.TYPE_UPC.UPC_EAN13, Val(leading), BarcodeCE.BARCODE_FIT.TIGHT, hpercent)
			'wid = orbarcodece.DrawUPC("201520", "01008", extra, x, y, BarcodeCE.BARCODE_FONTSIZE.NO_TEXT, BarcodeCE.TYPE_UPC.UPC_EAN13, Val(5), BarcodeCE.BARCODE_FIT.TIGHT, 65)
		Catch
    		orbarcodece.ShutDown()
		
		Finally
		
      		'orbarcodece.ShutDown()
    	End Try
    	
    	return wid
		
	End Function

    Public Sub DrawTextFlow(ByVal drawstring As String, x as Double, y as Double)
        'orBarcodeCE.DrawTextFlow(drawstring, PrinterCE.FLOW_OPTIONS.DEFAULT + PrinterCE.FLOW_OPTIONS.NOFORMFEED)
        
        orBarcodeCE.ScaleMode = barcodece.MEASUREMENT_UNITS.CENTIMETERS 
        
        orBarcodeCE.DrawTextFlow(drawstring, x, y, -1, -1, -1, -1, -1, PrinterCE.FLOW_OPTIONS.DEFAULT + PrinterCE.FLOW_OPTIONS.NOFORMFEED)

    End Sub

    Private disposedValue As Boolean = False        ' To detect redundant calls

    ' IDisposable
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: free unmanaged resources when explicitly called
                orBarcodeCE.Dispose(disposing)
            End If

            ' TODO: free shared unmanaged resources
        End If
        Me.disposedValue = True
    End Sub

#Region " IDisposable Support "
    ' This code added by Visual Basic to correctly implement the disposable pattern.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region

End Class
